'''All non-user configurations and definitions'''

# FILES
CONF_FILE = 'config.cfg'

# DEFAULT SETTINGS
KEY_MAP = {
    'UP': 'WKEY',
    'DOWN': 'SKEY',
    'LEFT': 'AKEY',
    'RIGHT': 'DKEY',
}

MOUSE_MAP = {
    'SELECT': 'LEFTMOUSE',
    'MOVE': 'RIGHTMOUSE',
    'VIEW': 'MIDDLEMOUSE',
    'ZOOMIN': 'WHEELUPMOUSE',
    'ZOOMOUT': 'WHEELDOWNMOUSE',
    'MINIMAPVIEW': 'LEFTMOUSE',
    'MINIMAPMOVE': 'RIGHTMOUSE',
}

# PARAMETERS
MIN_ZOOM = 2
MAX_ZOOM = 5
ZOOM_SPEED = 0.2
SCROLL_ROTATE_SPEED = 0.2

MOVE_SPEED = 0.1
MAX_ELEVATION = 0.1  # 0 is the top
MIN_ELEVATION = 1.25
ELEVATION_SENSITIVITY = 0.5
ROTATION_SENSITIVITY = 0.5

# BLENDER ENTITIES
UI_SCENE_NAME = 'UI'
GAME_SCENE_NAME = 'Game'
MAIN_SCREEN_OBJ = 'MainScreen'
MAIN_SCREEN_CAM = 'GameCam'
MINIMAP_SCREEN_OBJ = 'Minimap'
MINIMAP_SCREEN_CAM = 'MinimapCam'
ECONOMY_DISPLAY = 'EconomyDisplay'


# QUALITY SETTINGS
NUM_LIGHTS = 5
EXIT_ON_ERROR = True



# BLENDS
LIGHT_BLENDS = ['Models/Lights/Point.blend']
TILE_BLENDS = [
    'Models/Map/Tile.blend',
    'Models/Map/Crystal.blend',
    'Models/Buildings/Concrete Pad.blend',
    'Models/Buildings/Light Tower.blend',
    'Models/Buildings/Entry.blend',
    'Models/Units/Miner.blend',
    'Models/Units/Resource Transport.blend',
]


# MAP CONFIG
WORLD_SIZE = 50
BEDROCK_THRESHOLD = 0.2
BEDROCK_SCALE = 0.2
METAL_THRESHOLD = 0.5
NUM_CRYSTAL_ATTEMPTS = 20

# RESOURCES
START_RESOURCES = {
    'Crystal': 20,
    'Ore': 1000,
}
MINE_RATE = 5  # per second
ORE_GATHER_RATE = {  # The rate at which metal is gathered per stone hardness
    (0, 1): 0,
    (1, 2): 10,
    (2, 10): 1,
}


BUTTON_LIST = [
    {'type': 'Building', 'name': 'ConcretePad', 'Crystal': 0, 'Ore': 50},
    {'type': 'Building', 'name': 'LightTower', 'Crystal': 0, 'Ore': 150},
    {'type': 'Unit', 'unit_type': 'Mine', 'obj_name': 'Miner', 'level': 0, 'Crystal': 0, 'Ore': 150},
    {'type': None},
    {'type': 'Unit', 'unit_type': 'Resource', 'obj_name': 'Resource Truck', 'level':0, 'Crystal': 5, 'Ore': 300},
]

MINING_VEHICLE_LEVELS = [
    {'mining_speed': 1, 'resource_limit': {'Ore': 100, 'Crystal': 10}, 'rough_speed': 0.5, 'smooth_speed': 1},
    {'mining_speed': 3, 'resource_limit': {'Ore': 150, 'Crystal': 30}, 'rough_speed': 0.6, 'smooth_speed': 0.7}
]

RESOURCE_VEHILCE_LEVELS = [
    {'resource_limit': {'Ore': 500, 'Crystal': 50}, 'rough_speed': 1, 'smooth_speed': 2}
]
